#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "agi-namelookup.h"


/*
*    TSV to binary conversion program for namelookup.agi
*
*    Author: R.J. van der Putten, Leiden, Holland, 
*    rob at sput dot nl.
* 
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License version 3 as
*    published by the Free Software Foundation.
* 
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*/


int main(int argc, char **argv)
{
    char line[4096];
    int fc, i, j, k, len, lenfld, lenflg, numlen;
    struct phnum phonenum;

    fc = 0;
    i = 0;
    j = 0;
    k = 0;
    len = 0;
    lenfld = 0;
    lenflg = 0;
    numlen = 0;
    memset(line, 0, 4096);
    memset(&phonenum, 0, sizeof(phonenum));

    while (i < argc) {
	if (strcmp(argv[i], "-l") == 0) {
	    lenflg = 1;
	    break;
	}
	i++;
    }

    while (fgets(line, 4096, stdin)) {
	len = strlen(line);
	fc = 0;
	i = 0;
	j = 0;
	k = 0;
	lenfld = 0;
	numlen = 0;
	memset(&phonenum, 0, sizeof(phonenum));
	/*
	*  Number <Tab> Name <Line Feed>
	*  Or
	*  Number <Tab> Name <Tab> Len <Line Feed>
	*/
	while (i < len) {
	    if (line[i] == 9) {
		line[i] = 0;
		if (fc == 0) {
		    /*  1st field  */
		    strncpy(phonenum.num, line, ANL_NUM_MAX);
		    phonenum.num[ANL_NUM_MAX] = 0;
		    j = i + 1;
		    numlen = i;
		    if (numlen > ANL_NUM_MAX) {
			/*  Limit length  */
			numlen = ANL_NUM_MAX;
		    }
		    if (lenflg != 0) {
			/*  Write length  */
			phonenum.len = numlen;
		    }
		} else if (lenflg == 0) {
		    k = i + 1;
		}
		fc++;
		if (fc > 2) {
		    fprintf(stderr, "Too many fields\n");
		    exit(1);
		}
	    } else if (line[i] < ' ' && line[i] > -1) {
		/*  Non-Tab Ctrl; Last field  */
		line[i] = 0;
		strncpy(phonenum.name, line + j, ANL_NAME_MAX);
		phonenum.name[ANL_NAME_MAX] = 0;
		if (k != 0 && line[k] != 0 && (lenfld = atoi(line + k)) != 0) {
		    if (numlen == lenfld) {
			phonenum.len = numlen;
		    } else {
			fprintf(stderr, "Number length mismatch: %s %s\n", \
			  line, line + k);
			exit(1);
		    }
		}
		fwrite(&phonenum, sizeof(phonenum), 1, stdout);
		break;
	    }
	    i++;
	}
    }

    return(0);
}

